const {createMacro} = require("babel-plugin-macros") 
// const printAST = require("ast-pretty-print") 
const loadLanguages = require("macros")
const Prism = require("prismjs") 

module.exports = createMacro(jsx) 


function jsx({references, state, babel: {types: t}, config = {}}) {
    const wrapCode = (str) => {
        loadLanguages(["jsx"])
        const highCode = Prism.highlight(str, Prism.languages.jsx, "jsx")
        return t.stringLiteral(highCode)
    }
    references.default.forEach(reference => {
        const [firstArgumentPath] = reference.parentPath.get("arguments")

        const functionCallPath = firstArgumentPath.parentPath

        if (t.isIdentifier(firstArgumentPath)) {
            const programPath = reference.find((path) => path.isProgram())
            const nameArg = firstArgumentPath.node.name
            programPath.traverse({
                TemplateElement(path) {
                    const parentDeclarator = path.findParent((path) => path.isVariableDeclarator())
                    if (parentDeclarator && parentDeclarator.node.id.name === nameArg) {
                        const str = path.node.value.raw
                        functionCallPath.replaceWith(wrapCode(str))
                    }
                },
            })
        } else {
            const str = firstArgumentPath.node.quasis[0].value.cooked
            functionCallPath.replaceWith(wrapCode(str))
        }
    })
}